* MORAL HAZARD 2 Activities
* High effort case
*
* Itoh, H. (2003) A Course in Contract Theory, 4.2.2, p.161.
Option limcol=0, limrow=0;

* Definition of Set
Set     x       project outcome /failure, success/
        y       effort level    /low, high/
        z(y)    preferred effort level /high/;

* Definition of Parameters
Table p(x,y)    probability of outcome by effort level
        low     high
failure 0.9     0.2
success 0.1     0.8
;

Parameter       d(y)    disutility by efforts
        /low    1
        high    2/
;
Parameter       r(x) project's interest
        /failure 13
        success  45/
;


* Definition of Primal Variables
Positive Variable
                w(x)    entrep's income
;

Variable        U       investor's expected utility
;
Equation
                obj     utility function
                pc(z)   participation constraint
                ic(z,y) incentive compatibility constraint
;

* Defining and Solving the Model
*more active efforts
obj..           U =e= sum((x,z), p(x,z)*(r(x) - w(x)));
pc(z)..         sum(x,p(x,z)*sqrt(w(x)))-d(z) =g= 0;
ic(z,y)..       sum(x,p(x,z)*sqrt(w(x)))-d(z) =g=
                sum(x,p(x,y)*sqrt(w(x)))-d(y);

* Setting Lower Bounds on Variables to Avoid Division by Zero
w.lo(x)=0.0001;

Model MH001  /obj,pc,ic/;
Solve MH001 maximizing U using NLP;

Parameter
        u_e(x)  entrep's utility
        C       investers expected payment
        B       investers expected revenue
        Net     investers expected utility
;

u_e(x)  =sqrt(w.l(x));
C       =sum((x,z), p(x,z)*w.l(x));
B       =sum((x,z), p(x,z)*r(x));
Net     =B-C;
Display u_e, C, B, Net;
* End of Model
